/* binchop - try and make sense of human readable binary representations of magstripes
 *
 * bobbyrite (B) 2006, Major Malfunction <majormal@pirate-radio.org> - all rites reserved, all wrongs revenged
 * 
 */


#include <unistd.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

int main(int argc, char **argv)
{
	int i, j, k, n, chop, value, elements, parity, done;
	char *stripe, *current, *thiscurrent, *par, single[2];

	if (argc != 3) {
		printf( "\nusage: %s <BINARY STRING> <CHOP LENGTH>\n\n",argv[0]);
		return 1;
	}
	stripe=argv[1];
	chop= atoi(argv[2]);
	current=stripe;
	i=1;
	while (*current) {
		if(*current == '1')
			break;
		++i;
		++current;
	}
	printf("\n\nfirst 1 at bit: %d\nchopping at bit:\n\n",i);
	for(n= 0 ; n < chop ; ++n)
		printf("% *d",chop + 9,i - (chop - 1) + n);
	printf("\n\n   ");
	i -= (chop - 1);
	current -= (chop - 1);
	single[1]= '\0';
	elements= 0;
	done= 0;
	while(i < strlen(stripe) && !done) {
		for(n= 0 ; n < chop ; ++n) {
			thiscurrent= current;
			if (!strrchr (thiscurrent + n,'1')) {
				done= 1;
				break;
			}
			printf("%.*s ",chop,thiscurrent + n);
			value= k= 0;
			j= chop - 1;
			parity= 0;
			while (j >= 0) {
				single[0]= *(thiscurrent + n + k);
				value += (atoi(single) << j);
				parity += atoi(single);
				--j;
				++k;
			}
			if(parity % 2)
				par="O";
			else
				par="E";
			printf ("%.3i %s   ",value,par);
		}
		current += chop;
		i += chop;
		++elements;
		printf("\n   ");
	}
	printf("\n\nTotal elements: %d\n",elements);
	return 0;
}

